<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/DTS/ProtoDUNE_TimingSystem/pdts_scmd_gen_chan.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_d5f2f5bed3199c43277086728111e9c9.html">DTS</a></li><li class="navelem"><a class="el" href="dir_90267f26e899dc7372f7f3f7704d6d52.html">ProtoDUNE_TimingSystem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pdts_scmd_gen_chan.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-- pdts_scmd_gen_chan</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- Generates random sync commands</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- div words indicates power <span class="vhdlkeyword">of</span> two <span class="vhdlkeyword">to</span> divide rate by, <span class="vhdlkeyword">with</span> </span><span class="vhdllogic">256</span> prescale<span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">-- e.g. at 50MHz clock, div = </span><span class="vhdllogic">0</span> <span class="vhdlkeyword">is</span> <span class="vhdllogic">12</span>.2kHz, div = <span class="vhdllogic">7</span> <span class="vhdlkeyword">is</span> <span class="vhdllogic">95</span>.4Hz, div = <span class="vhdllogic">15</span> <span class="vhdlkeyword">is</span> <span class="vhdllogic">0</span>.373Hz<span class="keyword"></span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">-- Dave Newbold, March </span><span class="vhdllogic">2017</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="vhdlkeyword">use </span>IEEE.STD_LOGIC_1164.<span class="vhdlkeyword">ALL</span>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_misc.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="vhdlkeyword">use </span>work.ipbus.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="vhdlkeyword">use </span>work.ipbus_reg_types.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classpdts__defs.html">pdts_defs</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="code" href="classpdts__scmd__gen__chan.html">   20</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classpdts__scmd__gen__chan.html">pdts_scmd_gen_chan</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlkeyword">generic</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="vhdlchar">ID</span><span class="vhdlchar">:</span> <span class="comment">natural</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="vhdlkeyword">port</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="vhdlchar">ipb_clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="vhdlchar">ipb_rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="vhdlchar">ipb_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">ipb_wbus</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="vhdlchar">ipb_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">ipb_rbus</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="vhdlchar">clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="vhdlchar">rst</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="vhdlchar">tstamp</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span> <span class="vhdlchar">*</span> <span class="vhdlchar">TSTAMP_WDS</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="vhdlchar">rand</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="vhdlchar">scmd_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">cmd_w</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="vhdlchar">scmd_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">cmd_r</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="vhdlchar">ack</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="vhdlchar">rej</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">pdts_scmd_gen_chan</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="code" href="classpdts__scmd__gen__chan_1_1rtl.html">   41</a></span>&#160;<span class="vhdlkeyword">architecture</span> rtl <span class="vhdlkeyword">of</span> <a class="code" href="classpdts__scmd__gen__chan.html">pdts_scmd_gen_chan</a> is</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="vhdlkeyword">constant</span> <span class="vhdlchar">ID_V</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span> <span class="vhdlchar">:=</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">to_unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">ID</span><span class="vhdlchar">,</span> <span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipb_reg_v</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">stb</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">ctrl_en</span><span class="vhdlchar">,</span> <span class="vhdlchar">ctrl_patt</span><span class="vhdlchar">,</span> <span class="vhdlchar">ctrl_force</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">ctrl_type</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">ctrl_rate_div</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">r_i</span><span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlkeyword">range</span> <span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlchar">*</span><span class="vhdlchar">*</span> <span class="vhdllogic"></span><span class="vhdllogic">4</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">mask</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">src</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">26</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="vhdlkeyword">signal</span> <span class="vhdlchar">v</span><span class="vhdlchar">,</span> <span class="vhdlchar">valid</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    csr: <span class="vhdlkeyword">entity</span> work.ipbus_syncreg_v</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            N_CTRL  =&gt; <span class="vhdllogic">1</span>,</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            N_STAT  =&gt; <span class="vhdllogic">0</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            clk  =&gt; ipb_clk ,</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            rst  =&gt; ipb_rst ,</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            ipb_in  =&gt; ipb_in,</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            ipb_out  =&gt; ipb_out,</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            slv_clk  =&gt; clk,</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            q  =&gt; ctrl,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            qmask<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; X&quot;003fff07&quot;,</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            stb<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  =&gt; stb</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="vhdlchar">ctrl_en</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="vhdlchar">ctrl_patt</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="vhdlchar">ctrl_force</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="vhdlchar">ctrl_type</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="vhdlchar">ctrl_rate_div</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">19</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">16</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="vhdlchar">r_i</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">to_integer</span><span class="vhdlchar">(</span><span class="comment">unsigned</span><span class="vhdlchar">(</span><span class="vhdlchar">ctrl_rate_div</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="vhdlkeyword">process</span>(r_i)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="vhdlkeyword">    begin</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="vhdlkeyword">for</span> <span class="vhdlchar">i</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">mask</span><span class="vhdlchar">&#39;</span><span class="vhdlkeyword">range</span> <span class="vhdlkeyword">loop</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">i</span> <span class="vhdlchar">&gt;</span> <span class="vhdlchar">r_i</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                <span class="vhdlchar">mask</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                <span class="vhdlchar">mask</span><span class="vhdlchar">(</span><span class="vhdlchar">i</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">loop</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="vhdlchar">src</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">tstamp</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">26</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">ctrl_patt</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">rand</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">26</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="vhdlchar">v</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">(</span><span class="vhdlchar">src</span><span class="vhdlchar">(</span><span class="vhdlchar">r_i</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">11</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">r_i</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">ID_V</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">or_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">mask</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">src</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">22</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">or_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">src</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">ctrl_en</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">or</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="vhdlchar">(</span><span class="vhdlchar">ctrl_force</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">stb</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">else</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="vhdlchar">valid</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlchar">valid</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">(</span><span class="vhdlchar">v</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">scmd_in</span><span class="vhdlchar">.</span><span class="vhdlchar">ack</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">and</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">(</span><span class="vhdlchar">scmd_in</span><span class="vhdlchar">.</span><span class="vhdlchar">ren</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">rst</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">rising_edge</span><span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">)</span>;     </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="vhdlchar">scmd_out</span><span class="vhdlchar">.</span><span class="vhdlchar">d</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">ctrl_type</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="vhdlchar">scmd_out</span><span class="vhdlchar">.</span><span class="vhdlchar">valid</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">v</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">valid</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="vhdlchar">scmd_out</span><span class="vhdlchar">.</span><span class="vhdlchar">last</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="vhdlchar">ack</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">v</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">scmd_in</span><span class="vhdlchar">.</span><span class="vhdlchar">ack</span>;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="vhdlchar">rej</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">v</span> <span class="vhdlkeyword">and</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">scmd_in</span><span class="vhdlchar">.</span><span class="vhdlchar">ack</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">rtl</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
